define(["dojo/_base/declare","dojo/_base/array","dojo/_base/lang","dojo/on","dojo/when","dojo/dom-class","dojo/promise/all","dijit/_Widget","dijit/_TemplatedMixin","dijit/_WidgetsInTemplateMixin","epi/shell/dnd/Target","epi/shell/DialogService","epi/shell/widget/_ValueRequiredMixin","adaptiveimages/widget/editors/imagedetails/AdaptiveImageDetailsEditor","adaptiveimages/_LogMixin","adaptiveimages/AdaptiveImagesStore","adaptiveimages/helpers/ContentHelper","adaptiveimages/widget/dialog/AlternateTextDialog","adaptiveimages/widget/editors/mixins/_DropImageFileMixin","adaptiveimages/widget/editors/mixins/_CollectionItemEditorMixin","dojo/i18n!./nls/Labels","dojo/text!./AdaptiveImageEditor.html","xstyle/css!./AdaptiveImageEditor.css"],function(t,e,i,a,r,s,o,l,n,d,m,h,g,u,p,c,_,E,f,v,x,y){return t([l,n,d,g,p,f,v],{templateString:y,localized:x,debugLogName:"AdaptiveImageEditor",_target:null,_mostRecentDrop:null,_store:null,_imagesReadOnly:!1,_alternateTextReadOnly:!1,_masterLanguageVersion:null,displayNames:null,missingMessage:null,required:null,constructor:function(){this.inherited(arguments),this._store=new c},postMixInProperties:function(){this.inherited(arguments),this._setDisplayNames(),this.missingMessage=!0===this.metadata.customEditorSettings.required_alternateText?x.validation.requiredWithAlternateText.replace("{name}",this.label):x.validation.required.replace("{name}",this.label)},_configureEditorsForMasterLanguageFallback:function(){this._masterLanguageVersion&&((this._imagesReadOnly||this.readOnly)&&(this.log("Setting applicable editor values based on master language version...",this._masterLanguageVersion),s.add(this.dropzone,"dijitReadOnly"),this.largeEditor.set("width",this._masterLanguageVersion.large.width),this.mediumEditor.set("width",this._masterLanguageVersion.medium.width),this.smallEditor.set("width",this._masterLanguageVersion.small.width),this.largeEditor.set("height",this._masterLanguageVersion.large.height),this.mediumEditor.set("height",this._masterLanguageVersion.medium.height),this.smallEditor.set("height",this._masterLanguageVersion.small.height),this.largeEditor.set("left",this._masterLanguageVersion.large.crop.left),this.mediumEditor.set("left",this._masterLanguageVersion.medium.crop.left),this.smallEditor.set("left",this._masterLanguageVersion.small.crop.left),this.largeEditor.set("right",this._masterLanguageVersion.large.crop.right),this.mediumEditor.set("right",this._masterLanguageVersion.medium.crop.right),this.smallEditor.set("right",this._masterLanguageVersion.small.crop.right),this.largeEditor.set("top",this._masterLanguageVersion.large.crop.top),this.mediumEditor.set("top",this._masterLanguageVersion.medium.crop.top),this.smallEditor.set("top",this._masterLanguageVersion.small.crop.top),this.largeEditor.set("bottom",this._masterLanguageVersion.large.crop.bottom),this.mediumEditor.set("bottom",this._masterLanguageVersion.medium.crop.bottom),this.smallEditor.set("bottom",this._masterLanguageVersion.small.crop.bottom),this.largeEditor.set("filename",this._masterLanguageVersion.large.filename),this.mediumEditor.set("filename",this._masterLanguageVersion.medium.filename),this.smallEditor.set("filename",this._masterLanguageVersion.small.filename),this.largeEditor.set("provider",this._masterLanguageVersion.large.provider),this.mediumEditor.set("provider",this._masterLanguageVersion.medium.provider),this.smallEditor.set("provider",this._masterLanguageVersion.small.provider),this.largeEditor.set("imageId",this._masterLanguageVersion.large.id),this.mediumEditor.set("imageId",this._masterLanguageVersion.medium.id),this.smallEditor.set("imageId",this._masterLanguageVersion.small.id)),(this._alternateTextReadOnly||this.readOnly)&&(this.log("Using alternate text from master language"),this.largeEditor.set("alternateText",this._masterLanguageVersion.large.description),this.mediumEditor.set("alternateText",this._masterLanguageVersion.medium.description),this.smallEditor.set("alternateText",this._masterLanguageVersion.small.description)))},startup:function(){this.inherited(arguments),this.get("value")||this._setValueToCurrentCollectionItem()},postCreate:function(){this.inherited(arguments),this.log(`Setting up adaptive image property '${this.metadata.displayName||this.metadata.name}'...`,this);var t=this.metadata.customEditorSettings.master_language_value;t&&(this._masterLanguageVersion=JSON.parse(t),this.log("Parsed master language version value",this._masterLanguageVersion)),this.readOnly?(this.log("Property is in read-only state"),this.smallEditor.set("readOnly",!0),this.mediumEditor.set("readOnly",!0),this.largeEditor.set("readOnly",!0)):(this._setEditorPartialReadOnlyState(),this._alternateTextReadOnly||(this.log("Wiring up events for alternate text editing..."),a(this.altTextButton,"click",this._altTextButtonClick.bind(this))),this._imagesReadOnly||(this.log("Wiring up events for setting/editing images..."),this._target=new m(this.dropzone,{accept:["adaptiveimage","link"],createItemOnDrop:!1}),a(this._target,"DropData",this._onDrop.bind(this)),a(this.clearButton,"click",this._clearButtonClick.bind(this)),this.smallEditor.imageDropped=this._formFactorSpecificImageSet.bind(this),this.mediumEditor.imageDropped=this._formFactorSpecificImageSet.bind(this),this.largeEditor.imageDropped=this._formFactorSpecificImageSet.bind(this),this.smallEditor.imageCropped=this._formFactorSpecificImageCropped.bind(this),this.mediumEditor.imageCropped=this._formFactorSpecificImageCropped.bind(this),this.largeEditor.imageCropped=this._formFactorSpecificImageCropped.bind(this))),this._configureEditorsForMasterLanguageFallback(),this.onUploadComplete=function(t){t&&this._onDrop({data:t,type:["link"]})}},onChange:function(t){this.inherited(arguments)},isValid:function(t){if(!this.required)return!0;let a=this._createPropertyModel(),r=!0;const o=this.metadata.customEditorSettings.required_formFactors;this.log(`Validating required image property '${this.metadata.displayName}'...`,{value:this.get("value"),requiredFormFactors:o}),e.forEach(o,i.hitch(this,function(t,e){const i=this[`${t}Editor`];a[t].id&&a[t].provider?s.remove(i.domNode,"adaptiveimages-details-editor--error"):(this.logWarn(`The '${t}' form factor is required for the '${this.metadata.displayName}' property`,{value:a[t],editor:i}),s.add(i.domNode,"adaptiveimages-details-editor--error"),r=!1)}));const l=!0===this.metadata.customEditorSettings.required_alternateText;return r&&l&&!a.large.alternateText&&(r=!1),r?this.set("state",""):(this.logWarn(`The '${this.metadata.displayName}' property is required`,{requiredFormFactors:o,alternateTextRequired:l,value:this.get("value")}),this.set("state","Error")),r},_setValueToCurrentCollectionItem:function(){const t=this.getCurrentCollectionEditorItem();t&&(this.log("Inheriting value from current collection item...",t),this.set("value",t))},_setEditorPartialReadOnlyState:function(){!0===this.metadata.customEditorSettings.readonly_images&&(this._imagesReadOnly=!0,this.log("Images configured to be read-only"),this.smallEditor.set("readOnly",!0),this.mediumEditor.set("readOnly",!0),this.largeEditor.set("readOnly",!0),s.add(this.clearButton,"dijitReadOnly"),s.remove(this.clearButton,"hand-cursor")),!0===this.metadata.customEditorSettings.readonly_alternateText&&(this._alternateTextReadOnly=!0,this.log("Alternate text configured to be read-only"),s.add(this.altTextButton,"dijitReadOnly"),s.remove(this.altTextButton,"hand-cursor"))},_clearButtonClick:function(){this.set("value",this._createPropertyModel(!0)),this.isValid()},_getAlternateText:function(){return this.largeEditor.get("alternateText")||this.mediumEditor.get("alternateText")||this.smallEditor.get("alternateText")},_setAlternateText:function(t){if(t==this._getAlternateText())return;let e=(t||"").trim();""===e&&(e=null),this.largeEditor.set("alternateText",(e||"").trim()),this.mediumEditor.set("alternateText",e),this.smallEditor.set("alternateText",e),this.set("value",this._createPropertyModel()),this.isValid()},_altTextButtonClick:function(){let t;this.own(t=new E({model:{text:this._getAlternateText()},onOkAction:i.hitch(this,function(t){this._setAlternateText(t.text),this.log("Alternate text updated",{newText:t.text})})})),t.show()},_onDrop:function(t,e,i,a){this.log("Data drop",t);var s=t?t.length?t[0]:t:null;s&&r(s.data,function(t){if(s.type.includes("link")){var e=t.permanentUrl||t.permanentLink;r(_.getContentFromUrl(e),function(e){this.log("Episerver image dropped for all form factors, checking dimensions...",e),t.provider="episerver",t.imageId=e.contentGuid,t.name=e.name,t.filename=_.getFilenameFromUrl(e.publicUrl),r(_.getRemoteImageDimensions(e.downloadUrl),function(e){this.log(`Dropped image is ${e.width}x${e.height} pixels`),t.width=e.width,t.height=e.height,this._handleDropData(t)}.bind(this))}.bind(this))}else this.log("External image dropped for all form factors",t),t.filename||(t.filename=t.name),this._handleDropData(t)}.bind(this))},_handleDropData:function(t){if(t.imageId&&t.provider){var i=this.smallEditor.validateImageSizeAndProportions(t.width,t.height),a=this.mediumEditor.validateImageSizeAndProportions(t.width,t.height),s=this.largeEditor.validateImageSizeAndProportions(t.width,t.height);o([i,a,s]).then(function(i){this.log("Form factors validation result",i);var a=[];if(e.forEach(i,function(t,e){t.validSize&&t.validProportions||a.push(t)}),a&&a.length>0){var s=e.map(a,function(t,e){var i;return t.validSize||t.validProportions?t.validSize?t.validProportions||(i=x.dialogs.validationFailed.errorProportions):t.sizeConstraint.width>0&&t.sizeConstraint.height>0?i=t.imageSize.height<t.sizeConstraint.height&&t.imageSize.width<t.sizeConstraint.width?x.dialogs.validationFailed.errorSize:t.imageSize.height<t.sizeConstraint.height?x.dialogs.validationFailed.errorHeight:x.dialogs.validationFailed.errorWidth:t.sizeConstraint.width>0?i=x.dialogs.validationFailed.errorWidth:t.sizeConstraint.height>0&&(i=x.dialogs.validationFailed.errorHeight):i=x.dialogs.validationFailed.errorSizeAndProportions,i.replace("{formFactor}",t.displayName).replace("{width}",t.sizeConstraint.width).replace("{height}",t.sizeConstraint.height).replace("{size}",`${t.sizeConstraint.width}x${t.sizeConstraint.height}`).replace("{x}",t.proportionsConstraint.x).replace("{y}",t.proportionsConstraint.y)}),o=a[0].imageSize,l=x.dialogs.validationFailed.title.replace("{size}",`${o.width}x${o.height}`);h.alertWithErrors({title:"Titel",heading:l},s)}else r(h.confirmation({title:x.dialogs.replaceAll.title,description:x.dialogs.replaceAll.content}),function(){this._mostRecentDrop=t,this._replaceForAll()}.bind(this))}.bind(this))}else this.logWarn("Unexpected drop",t)},_replaceForAll:function(){this.log("Replacing image for all form factors...",this._mostRecentDrop.imageId);var t={left:null,right:null,top:null,bottom:null,id:this._mostRecentDrop.imageId?this._mostRecentDrop.imageId.toString():"",provider:this._mostRecentDrop.provider,filename:this._mostRecentDrop.filename,width:this._mostRecentDrop.width,height:this._mostRecentDrop.height,alternateText:this._getAlternateText()};this.set("value",{small:t,medium:t,large:t}),this.isValid()},_setValueAttr:function(t){this.log("Setting property value",t),this.onFocus(),this._set("value",t),this._refreshEditors(),this.onChange(t)},_formFactorSpecificImageSet:function(t,e,i){this.log(`Image for form factor '${i}' set`,e),this[`${i}Editor`].set("alternateText",this._getAlternateText()),this.set("value",this._createPropertyModel()),this.isValid()},_formFactorSpecificImageCropped:function(t,e){this.log(`Image for form factor '${e}' was cropped`,t),this.set("value",this._createPropertyModel())},_refreshEditors:function(){var t=this.get("value");null===t&&(this.log("No property value, assigning empty instance"),t=this._createPropertyModel(!0)),this.log("Refreshing editors",t),this.smallEditor.set("proportions",{x:this.metadata.customEditorSettings.proportions_small_x,y:this.metadata.customEditorSettings.proportions_small_y}),this.mediumEditor.set("proportions",{x:this.metadata.customEditorSettings.proportions_medium_x,y:this.metadata.customEditorSettings.proportions_medium_y}),this.largeEditor.set("proportions",{x:this.metadata.customEditorSettings.proportions_large_x,y:this.metadata.customEditorSettings.proportions_large_y}),this.smallEditor.set("minimumSize",{width:this.metadata.customEditorSettings.minimum_width_small||0,height:this.metadata.customEditorSettings.minimum_height_small||0}),this.mediumEditor.set("minimumSize",{width:this.metadata.customEditorSettings.minimum_width_medium||0,height:this.metadata.customEditorSettings.minimum_height_medium||0}),this.largeEditor.set("minimumSize",{width:this.metadata.customEditorSettings.minimum_width_large||0,height:this.metadata.customEditorSettings.minimum_height_large||0}),this._configureEditorsForMasterLanguageFallback(),this._alternateTextReadOnly||(this.smallEditor.set("alternateText",t.small.alternateText),this.mediumEditor.set("alternateText",t.medium.alternateText),this.largeEditor.set("alternateText",t.large.alternateText)),this._imagesReadOnly||(this.smallEditor.set("width",t.small.width),this.mediumEditor.set("width",t.medium.width),this.largeEditor.set("width",t.large.width),this.smallEditor.set("height",t.small.height),this.mediumEditor.set("height",t.medium.height),this.largeEditor.set("height",t.large.height),this.smallEditor.set("left",t.small.left),this.mediumEditor.set("left",t.medium.left),this.largeEditor.set("left",t.large.left),this.smallEditor.set("right",t.small.right),this.mediumEditor.set("right",t.medium.right),this.largeEditor.set("right",t.large.right),this.smallEditor.set("top",t.small.top),this.mediumEditor.set("top",t.medium.top),this.largeEditor.set("top",t.large.top),this.smallEditor.set("bottom",t.small.bottom),this.mediumEditor.set("bottom",t.medium.bottom),this.largeEditor.set("bottom",t.large.bottom),this.smallEditor.set("provider",t.small.provider),this.mediumEditor.set("provider",t.medium.provider),this.largeEditor.set("provider",t.large.provider),this.smallEditor.set("filename",t.small.filename),this.mediumEditor.set("filename",t.medium.filename),this.largeEditor.set("filename",t.large.filename),this.smallEditor.set("imageId",t.small.id),this.mediumEditor.set("imageId",t.medium.id),this.largeEditor.set("imageId",t.large.id)),this._getAlternateText()?s.add(this.altTextButton,"epi-icon--active"):s.remove(this.altTextButton,"epi-icon--active")},_createPropertyModel:function(t){if(t)return{small:{width:null,height:null,left:null,right:null,top:null,bottom:null,id:null,provider:null,alternateText:null},medium:{width:null,height:null,left:null,right:null,top:null,bottom:null,id:null,provider:null,alternateText:null},large:{width:null,height:null,left:null,right:null,top:null,bottom:null,id:null,provider:null,alternateText:null}};var i=["provider","filename","left","right","top","bottom","width","height","alternateText"],a={};return e.forEach(["small","medium","large"],function(t){var r={};const s=`${t}Editor`;var o=this[s];o?(e.forEach(i,function(t){this._alternateTextReadOnly&&"alternateText"===t&&(r[t]=null),this._imagesReadOnly&&"alternateText"!==t&&(r[t]=null);let e=o.get(t);void 0===e&&(e=null),r[t]=e}.bind(this)),r.id=o.get("imageId"),a[t]=r):this.logError(`There is no '${s}' editor`)}.bind(this)),this.log("Property model",a),a},_setDisplayNames:function(){const t=this.metadata.customEditorSettings.display_name_large||"",e=this.metadata.customEditorSettings.display_name_medium||"",i=this.metadata.customEditorSettings.display_name_small||"";this.displayNames={large:t.replace(/'/g,'"'),medium:e.replace(/'/g,'"'),small:i.replace(/'/g,'"')},this.log("Display names set",this.displayNames)}})});